module Sinatra
    module Authentication
        module Identification
            def authenticate(login, password)
                if user = find_by_login(login)
                    if Password::Hashing.check?(password, user.password)
                        user
                    end
                end
            end

            # NOTE: This is overridden in Ottoman.User
            def find_by_login(login)
                find(__LOGIN_FIELD__ => login).first
            end

        protected
            def __LOGIN_FIELD__
                LoginField.attr_name
            end
        end
    end
end
