require 'digest/sha2'

module Sinatra
    module Authentication
        module Password
            def self.included(model)
                # model.attribute :crypted_password
                # model.send :attr_accessor, :password, :password_confirmation
            end
        protected
            def write
                if !password.to_s.empty?
                    # NOTE: This is Ohm specific
                    # write_local :crypted_password, Hashing.encrypt(password)
                end

                super
            end

            module Hashing
                extend self

                def encrypt(password, salt = self.generate_salt)
                    serialize(hash(password, salt), salt)
                end

                def check?(password, crypted)
                    hash, salt = unserialize(crypted)
                    self.hash(password, salt) == hash
                end

            protected
                def generate_salt
                    salt = ""
                    64.times { salt << (i = Kernel.rand(62); i += ((i < 10) ? 48 : ((i < 36) ? 55 : 61))).chr }
                    salt
                end

                # This method can be customized
                def hash(password, salt)
                    Digest::SHA512.hexdigest("#{ password }:#{ salt }")
                end

                def serialize(hash, salt)
                    hash + salt
                end

                def unserialize(serialized)
                    return serialized[0..127], serialized[128..-1]
                end
            end
        end
    end
end
